package fmon

import fmon.util.YamlHelper

case class Config(
    val title: String,
    val crit: Double,
    val stab: Double,
    val resistMult: Double,
    val weakMult: Double,
    val immuneMult: Double,
    val maxBoost: Int,
    val tileSize: Int,
    val moveSpeed: Double,
    val yOffset: Int
  ) {
  
}

object Config {
  val config = YamlHelper.extract[Config](getClass.getResourceAsStream("config.yaml"))
  
  def title = config.title
  def crit = config.crit
  def stab = config.stab
  def resistMult = config.resistMult
  def weakMult = config.weakMult
  def immuneMult = config.immuneMult
  def maxBoost = config.maxBoost
  def tileSize = config.tileSize
  def moveSpeed = config.moveSpeed
  def yOffset = config.yOffset
  
  def homedir = raw"C:\Users\dalyj\Documents\Design\Project\"
}