package fmon.battle

import javafx.fxml.FXML
import javafx.scene.{control => jfxsc}

import scalafx.Includes._
import scalafx.scene.control._
import scalafx.scene.paint.Color

import fmon.stat.Move

class MoveButton {
  @FXML var moveBtn: jfxsc.Button = _
  @FXML var moveName: jfxsc.Label = _
  @FXML var moveUses: jfxsc.Label = _
  private var move: Move = _
  private var callback: Move => Unit = _
  
  def setup(mv: Move, callback: Move => Unit): Unit = {
    move = mv
    moveName.text = mv.name
    moveUses.text = s"${move.pp}/${move.pp}"
    moveBtn.style = s"-fx-background-color: ${colorString(mv.element.bgColor)}; -fx-text-fill: ${colorString(mv.element.fontColor)}"
    this.callback = callback
  }
  
  def moveActivate(): Unit = {
    callback(move)
  }
  
  def colorString(color: Color): String = {
    val s = color.toString()
    s"#${s.split("x")(1)}"
  }
}