package fmon.battle.msg

import fmon.stat.{Element, Monster}

case class AnimateMsg(val animation: String, target: Monster) extends Signal {
  
}

object AnimateMsg {
  def apply(element: Element, target: Monster): AnimateMsg = {
    val ani = element.name match {
      case "Poison" => "Poison Bubble"
      case "Electric" => "Lightning Lines"
      case "Fire" => "Rising Fire 1"
      case "Rock" => "Rock Blast"
      case "Ground" => "Stalagmites"
      case "Water" => "Rain"
      case "Flying" => "Gale"
      case "Ice" => "Glacier"
      case "Fairy" => "Light and Glass"
      case _ => "Buster"
    }
    AnimateMsg(ani, target)
  }
}