package fmon.stat

import scala.util.Random

import fmon._

class StorageMon(val nickname : String, val xp: Int, val gene : Gene, val form : Form, val evs : Map[Stat, Int], val moves : IndexedSeq[Move], val ability: Ability) {
  def level = form.xpCurve(xp)
}

object StorageMon {
  def generate(nickname: String, ot: TrainerID, xp: Int, form: Form, moves: IndexedSeq[Move])(implicit rng: Random) = {
    val gene = Gene.randomGene(ot, form)
    new StorageMon(nickname, xp, gene, form, Statistic.emptyEvs, moves, rng.pick(form.abilities))
  }
}